diff --git a/test/Makefile.inc b/test/Makefile.inc
index 8bd21432..a45fcf87 100644
--- a/test/Makefile.inc
+++ b/test/Makefile.inc
@@ -18,7 +18,7 @@ INCFLAGS = \
 AM_CPPFLAGS = $(INCFLAGS)
 AM_CFLAGS = $(CUNIT_CFLAGS)
 
-AM_LDFLAGS = -L$(LIB)
+AM_LDFLAGS = -L$(LIB) -static
 
 @VALGRIND_CHECK_RULES@
 valgrind_tools = memcheck
diff --git a/test/common_plat/miscellaneous/Makefile.am b/test/common_plat/miscellaneous/Makefile.am
index 48240efe..5f2cc53d 100644
--- a/test/common_plat/miscellaneous/Makefile.am
+++ b/test/common_plat/miscellaneous/Makefile.am
@@ -7,6 +7,4 @@ endif
 
 odp_api_from_cpp_CXXFLAGS = $(AM_CXXFLAGS)
 
-odp_api_from_cpp_LDFLAGS = $(AM_LDFLAGS) -static
-
 odp_api_from_cpp_SOURCES = odp_api_from_cpp.cpp
diff --git a/test/common_plat/performance/Makefile.am b/test/common_plat/performance/Makefile.am
index c67de749..79e8e39a 100644
--- a/test/common_plat/performance/Makefile.am
+++ b/test/common_plat/performance/Makefile.am
@@ -24,19 +24,12 @@ endif
 
 bin_PROGRAMS = $(EXECUTABLES) $(COMPILE_ONLY)
 
-odp_bench_packet_LDFLAGS = $(AM_LDFLAGS) -static
 odp_bench_packet_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
-odp_crypto_LDFLAGS = $(AM_LDFLAGS) -static
 odp_crypto_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
-odp_pktio_perf_LDFLAGS = $(AM_LDFLAGS) -static
 odp_pktio_perf_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
-odp_l2fwd_LDFLAGS = $(AM_LDFLAGS) -static
 odp_l2fwd_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
-odp_pktio_ordered_LDFLAGS = $(AM_LDFLAGS) -static
 odp_pktio_ordered_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
-odp_sched_latency_LDFLAGS = $(AM_LDFLAGS) -static
 odp_sched_latency_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
-odp_scheduling_LDFLAGS = $(AM_LDFLAGS) -static
 odp_scheduling_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
 
 noinst_HEADERS = \
diff --git a/test/common_plat/validation/api/Makefile.inc b/test/common_plat/validation/api/Makefile.inc
index d763a817..c4e80eb7 100644
--- a/test/common_plat/validation/api/Makefile.inc
+++ b/test/common_plat/validation/api/Makefile.inc
@@ -3,7 +3,6 @@ include $(top_srcdir)/test/Makefile.inc
 COMMON_DIR = $(top_builddir)/test/common_plat/common
 
 AM_CFLAGS += -I$(top_srcdir)/test/common_plat/common
-AM_LDFLAGS += -static
 AM_LDFLAGS += $(DPDK_PMDS)
 
 AM_CFLAGS += $(CUNIT_CFLAGS)
diff --git a/test/linux-generic/mmap_vlan_ins/Makefile.am b/test/linux-generic/mmap_vlan_ins/Makefile.am
index 5fb6afd9..2f38e5c6 100644
--- a/test/linux-generic/mmap_vlan_ins/Makefile.am
+++ b/test/linux-generic/mmap_vlan_ins/Makefile.am
@@ -8,7 +8,6 @@ dist_check_SCRIPTS = vlan.pcap \
 test_SCRIPTS = $(dist_check_SCRIPTS)
 
 test_PROGRAMS = plat_mmap_vlan_ins$(EXEEXT)
-plat_mmap_vlan_ins_LDFLAGS = $(AM_LDFLAGS) -static
 plat_mmap_vlan_ins_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
 # Clonned from example odp_l2fwd simple
diff --git a/test/linux-generic/pktio_ipc/Makefile.am b/test/linux-generic/pktio_ipc/Makefile.am
index ad5de50b..eaa8bdd6 100644
--- a/test/linux-generic/pktio_ipc/Makefile.am
+++ b/test/linux-generic/pktio_ipc/Makefile.am
@@ -5,9 +5,7 @@ test_PROGRAMS = pktio_ipc1\
 		pktio_ipc2
 
 pktio_ipc1_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
-pktio_ipc1_LDFLAGS = $(AM_LDFLAGS) -static
 pktio_ipc2_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
-pktio_ipc2_LDFLAGS = $(AM_LDFLAGS) -static
 
 pktio_ipc1_SOURCES = pktio_ipc1.c ipc_common.c ipc_common.h
 pktio_ipc2_SOURCES = pktio_ipc2.c ipc_common.c ipc_common.h
diff --git a/test/linux-generic/validation/api/shmem/Makefile.am b/test/linux-generic/validation/api/shmem/Makefile.am
index 6ff77b00..962450e5 100644
--- a/test/linux-generic/validation/api/shmem/Makefile.am
+++ b/test/linux-generic/validation/api/shmem/Makefile.am
@@ -13,12 +13,10 @@ shmem_odp1_SOURCES = shmem_odp1.c shmem_odp1.h shmem_common.h
 shmem_odp1_CFLAGS = $(AM_CFLAGS) \
 		   $(INCCUNIT_COMMON) \
 		   $(INCODP)
-shmem_odp1_LDFLAGS = $(AM_LDFLAGS)
 shmem_odp1_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
 
 shmem_odp2_SOURCES = shmem_odp2.c shmem_odp2.h shmem_common.h
 shmem_odp2_CFLAGS = $(AM_CFLAGS) \
 		   $(INCCUNIT_COMMON) \
 		   $(INCODP)
-shmem_odp2_LDFLAGS = $(AM_LDFLAGS)
 shmem_odp2_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)