diff --git a/test/miscellaneous/Makefile.am b/test/miscellaneous/Makefile.am
index 7d42b07e1..3ea5d5e84 100644
--- a/test/miscellaneous/Makefile.am
+++ b/test/miscellaneous/Makefile.am
@@ -1,8 +1,8 @@
 include $(top_srcdir)/test/Makefile.inc
 
 if test_cpp
-bin_PROGRAMS =  odp_api_from_cpp$(EXEEXT)
-TESTS = odp_api_from_cpp$(EXEEXT)
+bin_PROGRAMS =  odp_api_from_cpp
+TESTS = odp_api_from_cpp
 endif
 
 odp_api_from_cpp_SOURCES = odp_api_from_cpp.cpp
diff --git a/test/performance/Makefile.am b/test/performance/Makefile.am
index 8d9fd3593..1dccd82e1 100644
--- a/test/performance/Makefile.am
+++ b/test/performance/Makefile.am
@@ -2,14 +2,14 @@ include $(top_srcdir)/test/Makefile.inc
 
 TESTS_ENVIRONMENT += TEST_DIR=${builddir}
 
-EXECUTABLES = odp_bench_packet$(EXEEXT) \
-			  odp_crypto$(EXEEXT) \
-			  odp_pktio_perf$(EXEEXT)
-
-COMPILE_ONLY = odp_l2fwd$(EXEEXT) \
-	       odp_pktio_ordered$(EXEEXT) \
-	       odp_sched_latency$(EXEEXT) \
-	       odp_scheduling$(EXEEXT)
+EXECUTABLES = odp_bench_packet \
+	      odp_crypto \
+	      odp_pktio_perf
+
+COMPILE_ONLY = odp_l2fwd \
+	       odp_pktio_ordered \
+	       odp_sched_latency \
+	       odp_scheduling
 
 TESTSCRIPTS = odp_l2fwd_run.sh \
 	      odp_pktio_ordered_run.sh \
diff --git a/test/validation/api/atomic/Makefile.am b/test/validation/api/atomic/Makefile.am
index b09d3b88c..859e3c51a 100644
--- a/test/validation/api/atomic/Makefile.am
+++ b/test/validation/api/atomic/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = atomic_main$(EXEEXT)
+test_PROGRAMS = atomic_main
 atomic_main_SOURCES = atomic_main.c atomic.c atomic.h
 atomic_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/barrier/Makefile.am b/test/validation/api/barrier/Makefile.am
index 4dfb1d1ec..b0310e3a5 100644
--- a/test/validation/api/barrier/Makefile.am
+++ b/test/validation/api/barrier/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = barrier_main$(EXEEXT)
+test_PROGRAMS = barrier_main
 barrier_main_SOURCES = barrier_main.c barrier.c barrier.h
 barrier_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/buffer/Makefile.am b/test/validation/api/buffer/Makefile.am
index ae6ce0a40..59639ff7b 100644
--- a/test/validation/api/buffer/Makefile.am
+++ b/test/validation/api/buffer/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = buffer_main$(EXEEXT)
+test_PROGRAMS = buffer_main
 buffer_main_SOURCES = buffer_main.c buffer.c buffer.h
 buffer_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/classification/Makefile.am b/test/validation/api/classification/Makefile.am
index f177528e0..b58703079 100644
--- a/test/validation/api/classification/Makefile.am
+++ b/test/validation/api/classification/Makefile.am
@@ -1,6 +1,6 @@
 include ../Makefile.inc
 
-test_PROGRAMS = classification_main$(EXEEXT)
+test_PROGRAMS = classification_main
 classification_main_SOURCES = classification_main.c \
 				   odp_classification_basic.c \
 				   odp_classification_tests.c \
diff --git a/test/validation/api/cpumask/Makefile.am b/test/validation/api/cpumask/Makefile.am
index ddafb9ab2..ff12f56f7 100644
--- a/test/validation/api/cpumask/Makefile.am
+++ b/test/validation/api/cpumask/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = cpumask_main$(EXEEXT)
+test_PROGRAMS = cpumask_main
 cpumask_main_SOURCES = cpumask_main.c cpumask.c cpumask.h
 cpumask_main_LDADD = $(LIBCPUMASK_COMMON) $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/crypto/Makefile.am b/test/validation/api/crypto/Makefile.am
index 6660e1b2b..94f1c1cae 100644
--- a/test/validation/api/crypto/Makefile.am
+++ b/test/validation/api/crypto/Makefile.am
@@ -1,6 +1,6 @@
 include ../Makefile.inc
 
-test_PROGRAMS = crypto_main$(EXEEXT)
+test_PROGRAMS = crypto_main
 crypto_main_SOURCES = crypto_main.c \
 		      crypto.c \
 		      crypto.h \
diff --git a/test/validation/api/errno/Makefile.am b/test/validation/api/errno/Makefile.am
index 8f7b2e88c..9eddfb482 100644
--- a/test/validation/api/errno/Makefile.am
+++ b/test/validation/api/errno/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = errno_main$(EXEEXT)
+test_PROGRAMS = errno_main
 errno_main_SOURCES = errno_main.c errno.c errno.h
 errno_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/hash/Makefile.am b/test/validation/api/hash/Makefile.am
index b37f2e003..bd098ffb6 100644
--- a/test/validation/api/hash/Makefile.am
+++ b/test/validation/api/hash/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = hash_main$(EXEEXT)
+test_PROGRAMS = hash_main
 hash_main_SOURCES = hash_main.c hash.c hash.h
 hash_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/init/Makefile.am b/test/validation/api/init/Makefile.am
index ba25c61f7..522c3a187 100644
--- a/test/validation/api/init/Makefile.am
+++ b/test/validation/api/init/Makefile.am
@@ -3,7 +3,7 @@ include ../Makefile.inc
 # most platforms are expected not to support multiple ODP inits
 # following each other: therefore 3 separate binaries are
 # created, each containing its ODP init test.
-test_PROGRAMS = init_main_abort$(EXEEXT) init_main_log$(EXEEXT) init_main_ok$(EXEEXT)
+test_PROGRAMS = init_main_abort init_main_log init_main_ok
 init_main_abort_SOURCES = init_main_abort.c init.c init.h
 init_main_log_SOURCES   = init_main_log.c init.c init.h
 init_main_ok_SOURCES    = init_main_ok.c init.c init.h
diff --git a/test/validation/api/lock/Makefile.am b/test/validation/api/lock/Makefile.am
index 80740282c..b434fe77c 100644
--- a/test/validation/api/lock/Makefile.am
+++ b/test/validation/api/lock/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = lock_main$(EXEEXT)
+test_PROGRAMS = lock_main
 lock_main_SOURCES = lock_main.c lock.c lock.h
 lock_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/packet/Makefile.am b/test/validation/api/packet/Makefile.am
index fb3569977..43300ed0d 100644
--- a/test/validation/api/packet/Makefile.am
+++ b/test/validation/api/packet/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = packet_main$(EXEEXT)
+test_PROGRAMS = packet_main
 packet_main_SOURCES = packet_main.c packet.c packet.h
 packet_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/pktio/Makefile.am b/test/validation/api/pktio/Makefile.am
index eb4b60383..a416fd1da 100644
--- a/test/validation/api/pktio/Makefile.am
+++ b/test/validation/api/pktio/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = pktio_main$(EXEEXT)
+test_PROGRAMS = pktio_main
 pktio_main_SOURCES = pktio_main.c parser.c parser.h pktio.c pktio.h
 pktio_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/pool/Makefile.am b/test/validation/api/pool/Makefile.am
index 85a37b053..9e7c42b51 100644
--- a/test/validation/api/pool/Makefile.am
+++ b/test/validation/api/pool/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = pool_main$(EXEEXT)
+test_PROGRAMS = pool_main
 pool_main_SOURCES = pool_main.c pool.c pool.h
 pool_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/queue/Makefile.am b/test/validation/api/queue/Makefile.am
index a5b6a9b10..9b1c6b777 100644
--- a/test/validation/api/queue/Makefile.am
+++ b/test/validation/api/queue/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = queue_main$(EXEEXT)
+test_PROGRAMS = queue_main
 queue_main_SOURCES = queue_main.c queue.c queue.h
 queue_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/random/Makefile.am b/test/validation/api/random/Makefile.am
index e026f045a..e9e7ffc06 100644
--- a/test/validation/api/random/Makefile.am
+++ b/test/validation/api/random/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = random_main$(EXEEXT)
+test_PROGRAMS = random_main
 random_main_SOURCES = random_main.c random.c random.h
 random_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/scheduler/Makefile.am b/test/validation/api/scheduler/Makefile.am
index 6c71b0100..34abf7d6a 100644
--- a/test/validation/api/scheduler/Makefile.am
+++ b/test/validation/api/scheduler/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = scheduler_main$(EXEEXT)
+test_PROGRAMS = scheduler_main
 scheduler_main_SOURCES = scheduler_main.c scheduler.c scheduler.h
 scheduler_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/shmem/Makefile.am b/test/validation/api/shmem/Makefile.am
index d955cc22e..8c5d7f700 100644
--- a/test/validation/api/shmem/Makefile.am
+++ b/test/validation/api/shmem/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = shmem_main$(EXEEXT)
+test_PROGRAMS = shmem_main
 shmem_main_SOURCES = shmem_main.c shmem.c shmem.h
 shmem_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/std_clib/Makefile.am b/test/validation/api/std_clib/Makefile.am
index 919c2556f..dc75c95cf 100644
--- a/test/validation/api/std_clib/Makefile.am
+++ b/test/validation/api/std_clib/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = std_clib_main$(EXEEXT)
+test_PROGRAMS = std_clib_main
 std_clib_main_SOURCES = std_clib_main.c std_clib.c std_clib.h
 std_clib_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/system/Makefile.am b/test/validation/api/system/Makefile.am
index 15e6d49a5..123d3a693 100644
--- a/test/validation/api/system/Makefile.am
+++ b/test/validation/api/system/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = system_main$(EXEEXT)
+test_PROGRAMS = system_main
 system_main_SOURCES = system_main.c system.c system.h
 system_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/thread/Makefile.am b/test/validation/api/thread/Makefile.am
index 59e136b24..1c56574f4 100644
--- a/test/validation/api/thread/Makefile.am
+++ b/test/validation/api/thread/Makefile.am
@@ -1,6 +1,6 @@
 include ../Makefile.inc
 
-test_PROGRAMS = thread_main$(EXEEXT)
+test_PROGRAMS = thread_main
 thread_main_CPPFLAGS = $(AM_CPPFLAGS) -DTEST_THRMASK
 thread_main_SOURCES = thread_main.c thread.c thread.h
 thread_main_LDADD = $(LIBTHRMASK_COMMON) $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/time/Makefile.am b/test/validation/api/time/Makefile.am
index faed577f0..669d1226b 100644
--- a/test/validation/api/time/Makefile.am
+++ b/test/validation/api/time/Makefile.am
@@ -7,7 +7,7 @@ TEST_EXTENSIONS = .sh
 
 TESTS = $(TESTSCRIPTS)
 
-test_PROGRAMS = time_main$(EXEEXT)
+test_PROGRAMS = time_main
 time_main_SOURCES = time_main.c time.c time_test.h
 time_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
 
diff --git a/test/validation/api/timer/Makefile.am b/test/validation/api/timer/Makefile.am
index 4f79020dd..c953dcb34 100644
--- a/test/validation/api/timer/Makefile.am
+++ b/test/validation/api/timer/Makefile.am
@@ -1,5 +1,5 @@
 include ../Makefile.inc
 
-test_PROGRAMS = timer_main$(EXEEXT)
+test_PROGRAMS = timer_main
 timer_main_SOURCES = timer_main.c timer.c timer.h
 timer_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/validation/api/traffic_mngr/Makefile.am b/test/validation/api/traffic_mngr/Makefile.am
index 3884a13c5..dc4f87092 100644
--- a/test/validation/api/traffic_mngr/Makefile.am
+++ b/test/validation/api/traffic_mngr/Makefile.am
@@ -7,7 +7,7 @@ TEST_EXTENSIONS = .sh
 
 TESTS = $(TESTSCRIPTS)
 
-test_PROGRAMS = traffic_mngr_main$(EXEEXT)
+test_PROGRAMS = traffic_mngr_main
 traffic_mngr_main_SOURCES = traffic_mngr_main.c traffic_mngr.c traffic_mngr.h
 traffic_mngr_main_LDADD = -lm $(LIBCUNIT_COMMON) $(LIBODP)
 