diff --git a/test/common/test_packet_parser.h b/test/common/test_packet_parser.h
index b7d02113e..d0a0582ab 100644
--- a/test/common/test_packet_parser.h
+++ b/test/common/test_packet_parser.h
@@ -333,6 +333,62 @@ static const uint8_t test_packet_ipv6_ipsec_esp[] = {
 	0x88, 0x37, 0x65, 0xab, 0x0d, 0xe9, 0x95, 0x3b
 };
 
+static const uint8_t test_packet_mcast_eth_ipv4_udp[] = {
+	0x03, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x02, 0x00,
+	0x00, 0x03, 0x04, 0x05, 0x08, 0x00, 0x45, 0x00,
+	0x00, 0x63, 0x00, 0x01, 0x00, 0x00, 0x40, 0x11,
+	0xC8, 0xDB, 0xC0, 0xA8, 0x00, 0x01, 0xEF, 0x01,
+	0x02, 0x03, 0x04, 0xD2, 0x16, 0x2E, 0x00, 0x4F,
+	0x25, 0x61, 0x54, 0x68, 0x69, 0x73, 0x20, 0x69,
+	0x73, 0x20, 0x6D, 0x79, 0x20, 0x64, 0x75, 0x6D,
+	0x6D, 0x79, 0x20, 0x70, 0x61, 0x79, 0x6C, 0x6F,
+	0x61, 0x64, 0x20, 0x73, 0x74, 0x72, 0x69, 0x6E,
+	0x67, 0x2E, 0x20, 0x54, 0x68, 0x65, 0x20, 0x6C,
+	0x65, 0x6E, 0x67, 0x74, 0x68, 0x20, 0x6F, 0x66,
+	0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x73, 0x74,
+	0x72, 0x69, 0x6E, 0x67, 0x20, 0x69, 0x73, 0x20,
+	0x37, 0x31, 0x20, 0x62, 0x79, 0x74, 0x65, 0x73,
+	0x2E
+};
+
+static const uint8_t test_packet_bcast_eth_ipv4_udp[] = {
+	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x02, 0x00,
+	0x00, 0x03, 0x04, 0x05, 0x08, 0x00, 0x45, 0x00,
+	0x00, 0x63, 0x00, 0x01, 0x00, 0x00, 0x40, 0x11,
+	0xB9, 0xE0, 0xC0, 0xA8, 0x00, 0x01, 0xFF, 0xFF,
+	0xFF, 0xFF, 0x04, 0xD2, 0x16, 0x2E, 0x00, 0x4F,
+	0x16, 0x66, 0x54, 0x68, 0x69, 0x73, 0x20, 0x69,
+	0x73, 0x20, 0x6D, 0x79, 0x20, 0x64, 0x75, 0x6D,
+	0x6D, 0x79, 0x20, 0x70, 0x61, 0x79, 0x6C, 0x6F,
+	0x61, 0x64, 0x20, 0x73, 0x74, 0x72, 0x69, 0x6E,
+	0x67, 0x2E, 0x20, 0x54, 0x68, 0x65, 0x20, 0x6C,
+	0x65, 0x6E, 0x67, 0x74, 0x68, 0x20, 0x6F, 0x66,
+	0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x73, 0x74,
+	0x72, 0x69, 0x6E, 0x67, 0x20, 0x69, 0x73, 0x20,
+	0x37, 0x31, 0x20, 0x62, 0x79, 0x74, 0x65, 0x73,
+	0x2E
+};
+
+static const uint8_t test_packet_mcast_eth_ipv6_udp[] = {
+	0x33, 0x33, 0x01, 0x02, 0x03, 0x04, 0x02, 0x00,
+	0x00, 0x03, 0x04, 0x05, 0x86, 0xDD, 0x60, 0x00,
+	0x00, 0x00, 0x00, 0x4F, 0x11, 0x40, 0xFE, 0x80,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0xFF, 0xFE, 0x03, 0x04, 0x05, 0xFF, 0x02,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
+	0x00, 0x02, 0x00, 0x03, 0x00, 0x04, 0x04, 0xD2,
+	0x16, 0x2E, 0x00, 0x4F, 0xD6, 0x79, 0x54, 0x68,
+	0x69, 0x73, 0x20, 0x69, 0x73, 0x20, 0x6D, 0x79,
+	0x20, 0x64, 0x75, 0x6D, 0x6D, 0x79, 0x20, 0x70,
+	0x61, 0x79, 0x6C, 0x6F, 0x61, 0x64, 0x20, 0x73,
+	0x74, 0x72, 0x69, 0x6E, 0x67, 0x2E, 0x20, 0x54,
+	0x68, 0x65, 0x20, 0x6C, 0x65, 0x6E, 0x67, 0x74,
+	0x68, 0x20, 0x6F, 0x66, 0x20, 0x74, 0x68, 0x69,
+	0x73, 0x20, 0x73, 0x74, 0x72, 0x69, 0x6E, 0x67,
+	0x20, 0x69, 0x73, 0x20, 0x37, 0x31, 0x20, 0x62,
+	0x79, 0x74, 0x65, 0x73, 0x2E
+};
+
 #ifdef __cplusplus
 }
 #endif
diff --git a/test/validation/api/packet/packet.c b/test/validation/api/packet/packet.c
index ccfe6e512..db3a47cf8 100644
--- a/test/validation/api/packet/packet.c
+++ b/test/validation/api/packet/packet.c
@@ -65,7 +65,10 @@ static uint32_t parse_test_pkt_len[] = {
 	sizeof(test_packet_ipv4_ipsec_ah),
 	sizeof(test_packet_ipv4_ipsec_esp),
 	sizeof(test_packet_ipv6_ipsec_ah),
-	sizeof(test_packet_ipv6_ipsec_esp)
+	sizeof(test_packet_ipv6_ipsec_esp),
+	sizeof(test_packet_mcast_eth_ipv4_udp),
+	sizeof(test_packet_bcast_eth_ipv4_udp),
+	sizeof(test_packet_mcast_eth_ipv6_udp)
 };
 
 #define packet_compare_offset(pkt1, off1, pkt2, off2, len) \
@@ -3051,6 +3054,109 @@ static void parse_eth_ipv6_ipsec_esp(void)
 	odp_packet_free_multi(pkt, num_pkt);
 }
 
+/* Ethernet mcast/IPv4 mcast/UDP */
+static void parse_mcast_eth_ipv4_udp(void)
+{
+	odp_packet_parse_param_t parse;
+	int i;
+	int num_pkt = PARSE_TEST_NUM_PKT;
+	odp_packet_t pkt[num_pkt];
+
+	parse_test_alloc(pkt, test_packet_mcast_eth_ipv4_udp,
+			 sizeof(test_packet_mcast_eth_ipv4_udp));
+
+	parse.proto = ODP_PROTO_ETH;
+	parse.last_layer = ODP_PROTO_LAYER_L4;
+	parse.chksums.all_chksum = 0;
+
+	CU_ASSERT(odp_packet_parse(pkt[0], 0, &parse) == 0);
+	CU_ASSERT(odp_packet_parse_multi(&pkt[1], parse_test.offset_zero,
+					 num_pkt - 1, &parse) == (num_pkt - 1));
+
+	for (i = 0; i < num_pkt; i++) {
+		CU_ASSERT(odp_packet_has_eth(pkt[i]));
+		CU_ASSERT(odp_packet_has_eth_mcast(pkt[i]));
+		CU_ASSERT(odp_packet_has_ipv4(pkt[i]));
+		CU_ASSERT(odp_packet_has_ip_mcast(pkt[i]));
+		CU_ASSERT(odp_packet_has_udp(pkt[i]));
+		CU_ASSERT(!odp_packet_has_ipv6(pkt[i]));
+		CU_ASSERT(!odp_packet_has_tcp(pkt[i]));
+		CU_ASSERT(!odp_packet_has_eth_bcast(pkt[i]));
+		CU_ASSERT(!odp_packet_has_ip_bcast(pkt[i]));
+	}
+
+	odp_packet_free_multi(pkt, num_pkt);
+}
+
+/* Ethernet bcast/IPv4 bcast/UDP */
+static void parse_bcast_eth_ipv4_udp(void)
+{
+	odp_packet_parse_param_t parse;
+	int i;
+	int num_pkt = PARSE_TEST_NUM_PKT;
+	odp_packet_t pkt[num_pkt];
+
+	parse_test_alloc(pkt, test_packet_bcast_eth_ipv4_udp,
+			 sizeof(test_packet_bcast_eth_ipv4_udp));
+
+	parse.proto = ODP_PROTO_ETH;
+	parse.last_layer = ODP_PROTO_LAYER_L4;
+	parse.chksums.all_chksum = 0;
+
+	CU_ASSERT(odp_packet_parse(pkt[0], 0, &parse) == 0);
+	CU_ASSERT(odp_packet_parse_multi(&pkt[1], parse_test.offset_zero,
+					 num_pkt - 1, &parse) == (num_pkt - 1));
+
+	for (i = 0; i < num_pkt; i++) {
+		CU_ASSERT(odp_packet_has_eth(pkt[i]));
+		CU_ASSERT(odp_packet_has_eth_bcast(pkt[i]));
+		/* API specifies that Ethernet broadcast is also multicast */
+		CU_ASSERT(odp_packet_has_eth_mcast(pkt[i]));
+		CU_ASSERT(odp_packet_has_ipv4(pkt[i]));
+		CU_ASSERT(odp_packet_has_ip_bcast(pkt[i]));
+		CU_ASSERT(odp_packet_has_udp(pkt[i]));
+		CU_ASSERT(!odp_packet_has_ipv6(pkt[i]));
+		CU_ASSERT(!odp_packet_has_tcp(pkt[i]));
+		CU_ASSERT(!odp_packet_has_ip_mcast(pkt[i]));
+	}
+
+	odp_packet_free_multi(pkt, num_pkt);
+}
+
+/* Ethernet mcast/IPv6 mcast/UDP */
+static void parse_mcast_eth_ipv6_udp(void)
+{
+	odp_packet_parse_param_t parse;
+	int i;
+	int num_pkt = PARSE_TEST_NUM_PKT;
+	odp_packet_t pkt[num_pkt];
+
+	parse_test_alloc(pkt, test_packet_mcast_eth_ipv6_udp,
+			 sizeof(test_packet_mcast_eth_ipv6_udp));
+
+	parse.proto = ODP_PROTO_ETH;
+	parse.last_layer = ODP_PROTO_LAYER_L4;
+	parse.chksums.all_chksum = 0;
+
+	CU_ASSERT(odp_packet_parse(pkt[0], 0, &parse) == 0);
+	CU_ASSERT(odp_packet_parse_multi(&pkt[1], parse_test.offset_zero,
+					 num_pkt - 1, &parse) == (num_pkt - 1));
+
+	for (i = 0; i < num_pkt; i++) {
+		CU_ASSERT(odp_packet_has_eth(pkt[i]));
+		CU_ASSERT(odp_packet_has_eth_mcast(pkt[i]));
+		CU_ASSERT(odp_packet_has_ipv6(pkt[i]));
+		CU_ASSERT(odp_packet_has_ip_mcast(pkt[i]));
+		CU_ASSERT(odp_packet_has_udp(pkt[i]));
+		CU_ASSERT(!odp_packet_has_ipv4(pkt[i]));
+		CU_ASSERT(!odp_packet_has_tcp(pkt[i]));
+		CU_ASSERT(!odp_packet_has_eth_bcast(pkt[i]));
+		CU_ASSERT(!odp_packet_has_ip_bcast(pkt[i]));
+	}
+
+	odp_packet_free_multi(pkt, num_pkt);
+}
+
 odp_testinfo_t packet_suite[] = {
 	ODP_TEST_INFO(packet_test_alloc_free),
 	ODP_TEST_INFO(packet_test_alloc_free_multi),
@@ -3102,6 +3208,9 @@ odp_testinfo_t packet_parse_suite[] = {
 	ODP_TEST_INFO(parse_eth_ipv4_ipsec_esp),
 	ODP_TEST_INFO(parse_eth_ipv6_ipsec_ah),
 	ODP_TEST_INFO(parse_eth_ipv6_ipsec_esp),
+	ODP_TEST_INFO(parse_mcast_eth_ipv4_udp),
+	ODP_TEST_INFO(parse_bcast_eth_ipv4_udp),
+	ODP_TEST_INFO(parse_mcast_eth_ipv6_udp),
 	ODP_TEST_INFO_NULL,
 };
 